#ifndef BOIL_POSTDATA_BUILDER_H_INCLUDED
#define BOIL_POSTDATA_BUILDER_H_INCLUDED

#include <vector>

class PostdataBuilder {
public:
    
    void append(char const *const key,
                char const *const value) {
        // behandelt Nullbytes nicht korrekt!
        if (!result.empty())
            result.push_back('&');
        append(key);
        result.push_back('=');
        append(value);
    }

    char const *get_result() {
        result.push_back('\0');
        return &result[0];
    }

private:

    void append(char const *str) {
        char c;
        while ((c = *str++))
            append(c);
    }

    void append(char const c) {
        if (c >= 'a' && c <= 'z'
            || c >= 'A' && c <= 'Z'
            || c >= '0' && c <= '9'
            || c == '-'
            || c == '.'
            || c == '_'
            || c == '~')
            result.push_back(c); // Zeichen nicht reserviert (RFC 3986)
        else if (c == ' ')
            result.push_back('+');
        else {
            // interpretiere string als binaer
            int const ord = int(c) & 0xFF;
            result.push_back('%');
            result.push_back(hexdigit(ord >> 4));
            result.push_back(hexdigit(ord & 0xF));
        }
    }

    static char hexdigit(int const digit) {
        static char const digits[] = "0123456789ABCDEF";
        return digits[digit];
    }

    std::vector<char> result;
};

#endif // def BOIL_POSTDATA_BUILDER_H_INCLUDED
